// -*-Mode: C++;-*- // technically C99

// * BeginRiceCopyright *****************************************************
//
// $HeadURL: http://hpctoolkit.googlecode.com/svn/trunk/src/tool/hpcrun/unwind/x86-family/x86-unwind-interval-fixup.c $
// $Id: x86-unwind-interval-fixup.c 4059 2013-01-02 20:08:23Z krentel $
//
// --------------------------------------------------------------------------
// Part of HPCToolkit (hpctoolkit.org)
//
// Information about sources of support for research and development of
// HPCToolkit is at 'hpctoolkit.org' and in 'README.Acknowledgments'.
// --------------------------------------------------------------------------
//
// Copyright ((c)) 2002-2013, Rice University
// All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are
// met:
//
// * Redistributions of source code must retain the above copyright
//   notice, this list of conditions and the following disclaimer.
//
// * Redistributions in binary form must reproduce the above copyright
//   notice, this list of conditions and the following disclaimer in the
//   documentation and/or other materials provided with the distribution.
//
// * Neither the name of Rice University (RICE) nor the names of its
//   contributors may be used to endorse or promote products derived from
//   this software without specific prior written permission.
//
// This software is provided by RICE and contributors "as is" and any
// express or implied warranties, including, but not limited to, the
// implied warranties of merchantability and fitness for a particular
// purpose are disclaimed. In no event shall RICE or contributors be
// liable for any direct, indirect, incidental, special, exemplary, or
// consequential damages (including, but not limited to, procurement of
// substitute goods or services; loss of use, data, or profits; or
// business interruption) however caused and on any theory of liability,
// whether in contract, strict liability, or tort (including negligence
// or otherwise) arising in any way out of the use of this software, even
// if advised of the possibility of such damage.
//
// ******************************************************* EndRiceCopyright *

#include <stdlib.h>
#include "x86-unwind-interval-fixup.h"

typedef struct x86_ui_fixup_list_item_s {
  x86_ui_fixup_fn_t fn;
  struct x86_ui_fixup_list_item_s *next;
} x86_ui_fixup_list_item_t; 

static x86_ui_fixup_list_item_t *x86_fixup_list = 0;


void 
add_x86_unwind_interval_fixup_function(x86_ui_fixup_fn_t fn)
{
   x86_ui_fixup_list_item_t *i = (x86_ui_fixup_list_item_t *) malloc(sizeof(x86_ui_fixup_list_item_t));
   i->next = x86_fixup_list;
   i->fn = fn;
   x86_fixup_list = i;
}

int
x86_fix_unwind_intervals(char *ins, int len, interval_status *stat)
{
   x86_ui_fixup_list_item_t *fentry = x86_fixup_list;
   while (fentry) {
    if ((*fentry->fn)(ins,len,stat)) return 1;
    fentry = fentry->next;
   }
   return 0;
}
